#include <iostream>

using namespace std;

void pkln(int a[],bool b[],int q){
    if(q==0) return;
    else{
        int l,d,p=0;
        cin>>l>>d;
        for(int j=l-1;j<d-1;j++)
            if(a[j]<a[j-1]){
                if(j-1>=l&&a[j]<a[j-2]&&a[j+1]<a[j-1])p++;
                if(p==1){
                    pkln(a,b,q-1);
                    b[q-1]=false;
                    p=2;
                    break;}
                else p++;
                }
        if(a[d-1]<a[d-2]&&p==1){
            pkln(a,b,q-1);
            b[q-1]=false;}
        else if(p!=2){
            pkln(a,b,q-1);
            b[q-1]=true;
        }
    }
}
int main()
{   int n,q;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++)
        cin>>a[i];
    cin>>q;
    bool b[q];
    pkln(a,b,q);
    for (int i=q-1;i>-1;i--)
        if(b[i])
            cout<<"DA"<<endl;
        else
            cout<<"NE"<<endl;
    return 0;
}